#!/usr/bin/env bash

# colors...
LIGHT_GREEN='\033[1;32m'
LIGHT_RED='\033[1;31m'
NC='\033[0m' # No Color

BASE_URL="http://127.0.0.1:5984"
DB_NAME="univ_rennes1"
PRETTY_PRINT="python -m json.tool"

# Make sure the DB is deleted before we start
curl -X DELETE ${BASE_URL}/${DB_NAME} &> /dev/null


echo -e "${LIGHT_GREEN}Création d'une base de données appelée '${DB_NAME}'${NC}"
COMMAND="curl -X PUT ${BASE_URL}/${DB_NAME}"
echo -e "${LIGHT_RED}${COMMAND}${NC}"
read -n 1 -s
${COMMAND} 2> /dev/null | ${PRETTY_PRINT}


echo -e "${LIGHT_GREEN}Lecture de la base de données créée${NC}"
COMMAND="curl -X GET ${BASE_URL}/${DB_NAME}"
echo -e "${LIGHT_RED}${COMMAND}${NC}"
read -n 1 -s
${COMMAND} 2> /dev/null | ${PRETTY_PRINT}


UUID=173fce259fccf5959b44c448110126c0
echo -e "${LIGHT_GREEN}Création d'un document ${UUID}${NC}"
COMMAND="curl -X PUT ${BASE_URL}/${DB_NAME}/${UUID} -d '{\"batiment\": \"12D\", \"salle\": 57, \"postes\": 20}'"
echo -e "${LIGHT_RED}${COMMAND}${NC}"
read -n 1 -s
eval ${COMMAND} 2> /dev/null | ${PRETTY_PRINT}


echo -e "${LIGHT_GREEN}Lecture du document créé${NC}"
COMMAND="curl -X GET ${BASE_URL}/${DB_NAME}/${UUID}"
echo -e "${LIGHT_RED}${COMMAND}${NC}"
read -n 1 -s
eval ${COMMAND} 2> /dev/null | ${PRETTY_PRINT}

echo -e "${LIGHT_GREEN}Suppression du document créé${NC}"
REV=$(eval ${COMMAND} 2> /dev/null | jq "._rev")
COMMAND="curl -X DELETE ${BASE_URL}/${DB_NAME}/${UUID}?rev=${REV}"
echo -e "${LIGHT_RED}${COMMAND}${NC}"
read -n 1 -s
eval ${COMMAND} 2> /dev/null | ${PRETTY_PRINT}

echo -e "${LIGHT_GREEN}Suppression de la base de données${NC}"
COMMAND="curl -X DELETE ${BASE_URL}/${DB_NAME}"
echo -e "${LIGHT_RED}${COMMAND}${NC}"
read -n 1 -s
eval ${COMMAND} 2> /dev/null | ${PRETTY_PRINT}

